%define name FJSVdr-util-RHEL7
%define version 1.1.0
%define release 1

%define dp_home_dir    /opt/FJSVdr-util
%define dp_etc_dir     /opt/FJSVdr-util/etc
%define dp_lib_dir     /opt/FJSVdr-util/lib
%define dp_libexec_dir /opt/FJSVdr-util/libexec
%define dp_core_dir    /opt/FJSVdr-util/libexec/dp-core
%define dp_sbin_dir    /opt/FJSVdr-util/sbin
%define dp_tools_dir   /opt/FJSVdr-util/tools
%define dp_log_dir     /opt/FJSVdr-util/var/log
%define dp_com_dir     /opt/FJSVdr-util/user_command
%define python_lib     /usr/lib/python2.7/site-packages
%define udev_rule_dir  /etc/udev/rules.d
%define systemd_dir    /usr/lib/systemd/system
%define default_grub	/etc/default/grub
%define grub_cfg	/boot/efi/EFI/redhat/grub.cfg
%define dp_boot_opt	"pci=hpiosize=0 pci=hpmemsize=8m pciehp.pciehp_force=1 notsc mem=0x40000000000"

Name:        %{name}
Version:     %{version}
Release:     %{release}
Summary:     Dynamic Reconfiguration utility for PRIMEQUEST 2000 series

Group:       System Environment/Base
License:     GPLv2
Vendor:      FUJITSU LIMITED
Packager:    FUJITSU LIMITED
URL:         http://www.fujitsu.com/
Source0:     %{name}-%{version}.tar.bz2
Source1:     10-FJSVdr-util-kdump-restart
Source2:     90-FJSVdr-util-detect-passthrough-dev
Source3:     89-FJSVdr-util-irqbalance-restart
Source4:     88-FJSVdr-util-detect-enabled-ksm-service
BuildRoot:   %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:   noarch
Obsoletes:   FJSVdr-util-RHEL6
Requires:    python >= 2.7
Requires:    grubby
Requires:    ipmitool
Requires:    kexec-tools
Requires:    OpenIPMI

%description
Provides a set of Dynamic Reconfiguration command user interface
and related service scripts. And also provides some Dynamic
Reconfiguration collaborate scripts.

%prep
%setup -q
#%patch1 -p1

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{dp_etc_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_lib_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_libexec_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_core_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_sbin_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_tools_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_log_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_com_dir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
mkdir -p $RPM_BUILD_ROOT%{systemd_dir}

# etc
install -m 0644 -o root -g root \
	etc/dr_report.conf $RPM_BUILD_ROOT%{dp_etc_dir}
# lib
install -m 0644 -o root -g root \
	lib/dp.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/ipmi.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/dp_compat.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/notify.py $RPM_BUILD_ROOT%{dp_lib_dir}
# libexec
install -m 0755 -o root -g root \
	libexec/udev_dp_bridge.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_send_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_send_not_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_event_daemon.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_event_notifier.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_enable_removable_sb.py $RPM_BUILD_ROOT%{dp_libexec_dir}
# dp-core
install -m 0755 -o root -g root \
	libexec/dp-core/dp_add.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_rm.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_show.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_stat.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_report.py $RPM_BUILD_ROOT%{dp_core_dir}
# sbin
install -m 0755 -o root -g root \
	sbin/dp $RPM_BUILD_ROOT%{dp_sbin_dir}/dr
# tools
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util.rules $RPM_BUILD_ROOT%{dp_tools_dir}
install -m 0755 -o root -g root \
	tools/udev_dp_bridge.sh $RPM_BUILD_ROOT%{dp_tools_dir}
# systemd service
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util-enable.service $RPM_BUILD_ROOT%{systemd_dir}
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util-event-daemon.service $RPM_BUILD_ROOT%{systemd_dir}
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util-enable-removable-sb.service $RPM_BUILD_ROOT%{systemd_dir}
# logrotate file
install -m 0644 -o root -g root tools/common/FJSVdr-util.logrotate \
	$RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/FJSVdr-util
# user_command
install -m 0755 -o root -g root %{SOURCE1} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE2} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE3} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE4} $RPM_BUILD_ROOT%{dp_com_dir}

%post
if [ "$1" = 1 ]; then  # when rpm -i
	## install service
	/usr/bin/systemctl enable FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl enable FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl enable FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
	
	## for kdump
	/bin/sed -i -e "s/^/#/g" /etc/udev/rules.d/98-kexec.rules
fi
## create symlinks
ln -sf $RPM_BUILD_ROOT%{dp_sbin_dir}/dr /sbin/dr
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp.py %{python_lib}/dp.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/ipmi.py %{python_lib}/ipmi.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp_compat.py %{python_lib}/dp_compat.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/notify.py %{python_lib}/notify.py
ln -sf $RPM_BUILD_ROOT%{dp_tools_dir}/FJSVdr-util.rules \
	$RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
## add boot option for DR
DP_BOOT_OPT=%{dp_boot_opt}
if [ -f %{default_grub} ]; then
	GRUB_CMDLINE_LINUX=`cat %{default_grub} | grep '^GRUB_CMDLINE_LINUX='|sed -e 's/GRUB_CMDLINE_LINUX=//g' | sed -e 's/^"//g' | sed -e 's/"$//g'`
	NEW_CMDLINE=$GRUB_CMDLINE_LINUX
	for DP_OPT in ${DP_BOOT_OPT[@]}
	do
	        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$DP_OPT'\>//g')
	        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/$/ '$DP_OPT'/g')
	done
	# cleanup obsolete dp options
	NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'pci=hpmemsize=4m'\>//g')

	NEW_CMDLINE="GRUB_CMDLINE_LINUX=\"$NEW_CMDLINE\""
	
	sed -i '/^GRUB_CMDLINE_LINUX=/d' %{default_grub}
	echo $NEW_CMDLINE >> %{default_grub}
	grub2-mkconfig -o %{grub_cfg} > /dev/null 2>&1
else
	KERNEL_LIST=$(/bin/ls /boot/vmlinuz-*)
	for KERNEL in ${KERNEL_LIST[@]}
	do
		/sbin/grubby --update-kernel $KERNEL --args="$DP_BOOT_OPT"
	done
fi

%preun
if [ "$1" = 0 ]; then  # when rpm -e
	## uninstall service
	/usr/bin/systemctl --no-reload disable FJSVdr-util-enable.service \
		>/dev/null 2>&1
	/usr/bin/systemctl --no-reload disable FJSVdr-util-event-daemon.service \
		>/dev/null 2>&1
	/usr/bin/systemctl --no-reload disable FJSVdr-util-enable-removable-sb.service \
		>/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
		
	## cleanup symlinks
	if [ -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py ];
	then
		rm -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py
	fi	
	if [ -f /sbin/dr ];
	then
		rm -f /sbin/dr
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py
	fi	
	if [ -f $RPM_BUILD_ROOT%{python_lib}/notify.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/notify.py
	fi	
	if [ -f $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules ];
	then
		rm -f $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
	fi
fi

%postun
if [ "$1" = 0 ]; then	# when rpm -e
    ## remove boot option for DR
	DP_BOOT_OPT=%{dp_boot_opt}
	if [ -f %{default_grub} ]; then
		GRUB_CMDLINE_LINUX=`cat %{default_grub} | grep '^GRUB_CMDLINE_LINUX='|sed -e 's/GRUB_CMDLINE_LINUX=//g' | sed -e 's/^"//g' | sed -e 's/"$//g'`
		NEW_CMDLINE=$GRUB_CMDLINE_LINUX
		for DP_OPT in ${DP_BOOT_OPT[@]}
		do
		        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$DP_OPT'\>//g')
		done
		# cleanup obsolete dp options
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'pci=hpmemsize=4m'\>//g')
		
		NEW_CMDLINE="GRUB_CMDLINE_LINUX=\"$NEW_CMDLINE\""
		
		sed -i '/^GRUB_CMDLINE_LINUX=/d' %{default_grub}
		echo $NEW_CMDLINE >> %{default_grub}
		grub2-mkconfig -o %{grub_cfg} > /dev/null 2>&1
	else
		KERNEL_LIST=$(/bin/ls /boot/vmlinuz-*)
		for KERNEL in ${KERNEL_LIST[@]}
		do
			/sbin/grubby --update-kernel $KERNEL --remove-args="$DP_BOOT_OPT"
		done
	fi
	## for kdump
	/bin/sed -i -e "s/^#//g" /etc/udev/rules.d/98-kexec.rules
fi
/usr/bin/systemctl daemon-reload >/dev/null 2>&1
if [ "$1" -ge 1 ]; then # upgrade, not uninstall
	/usr/bin/systemctl try-restart \
		FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl try-restart \
		FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl try-restart \
		FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
fi

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{dp_home_dir}
%config(noreplace) %{dp_etc_dir}/dr_report.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/FJSVdr-util
%{systemd_dir}/FJSVdr-util-enable.service
%{systemd_dir}/FJSVdr-util-event-daemon.service
%{systemd_dir}/FJSVdr-util-enable-removable-sb.service

%changelog
* Thu Aug 28 2014 FUJITSU LIMITED
- Do not send IPMI error code in case of minor errors in IOU hotplug
- Change the value of pci=hpmemsize boot option (Specfile)
- (BS01586)

* Thu Apr 30 2014 FUJITSU LIMITED
- first build
- (BS01571)


